;===============================================================
;  MSX STAR SOLDIER
;
;	自弾vsBG 当たり判定
;		軽量化
;		(自弾vs敵当たり判定に間借り)
;
;===============================================================
org	#50a2


proc_518e_hitchk_bg:
		ld		a,(#cddd)
		or		a
		jp		z,#548b		; 次キャラへ e-- if(e==0):0x50ae else:ret

	; スプライト座標をmap展開エリア座標(20x15)に
	; y: (spr_y + 8)/16
		ld		a,ixh
		sub		16-8		; map_yが0か12以上の場合、
		cp		192-(16-8)-8	;
		jp		nc,#548b		; 次キャラへ e-- if(e==0):0x50ae else:ret

		add		a,8 +(16-8)
		rrca
		rrca
		rrca
		rrca
		and		#f
		ld		h,a

	; x: (spr_x - 1)/16 *5/4	 値域:0〜19
		ld		a,ixl
		;dec		a
		srl		a
		ld		l,a
		srl		a
		srl		a
		add		a,l
        rrca
        rrca
        rrca
        and		#1f
		ld		l,a

		ld		(#ce74),hl

	;proc_51c7:
	; map展開エリアアドレス取得
	; [0xce76:2]=0xcc9d + ([0xce75]&15)*20 + [0xce74]
		;ld		hl,(#ce74)

		ld		a,h
		ld		b,x20tbl>>8
		add		a,x20tbl
		;jr		nc,_endx20tbl
		;inc		b
		;_endx20tbl:
		ld		c,a
		ld		a,(bc)

		add		a,l
		ld		h,#cc
		add		a,#9d
		ld		l,a
		jr		nc,_set76
		inc		h
	_set76:
		ld		(#ce76),hl
proc_51fc:
proc
	; mapピースごとに分岐
		ld		a,(hl)		; a=mapピース:[map展開エリア + map_y*20 + map_x]
		ld		(#ce7b),a	; [0xce7b]=mapピース
		cp		#21			; if mapピース < 0x21 :
		jr		c,_5214			; 0x5214 へ
		cp		#a8			; if mapピース < 0xa8 :
		jp		c,#548b			; 次キャラへ e-- if(e==0):0x50ae else:ret
		srl		a			; mapピース/8+12
		srl		a				; 
		srl		a				;
		add		a,12			; 0x21〜0x2b
	_5214:
		add		a,a			; mapピース*2
		ld		h,#525d>>8
		add		a,#525d
		ld		l,a
		ld		a,(hl)
		inc		l
		ld		h,(hl)
		ld		l,a
		ld		a,(#ce7b)	; a=mapピース
		jp		(hl)			;
endp

x20tbl:
		db	0,20,40,60,80,100,120,140,160,180,200,220,240



;===============================================================
;	mapパーツごとの処理修正
;===============================================================
; BG1個分左にずらして再チェック
proc_52bd:
		ld		hl,(#ce76)
		dec		hl
		ld		(#ce76),hl
		jp		proc_51fc
val_51c7_in_rom_12be	equ	proc_52bd

; BG1個分上にずらして再チェック
proc_52c4:
		ld		bc,-20
		ld		hl,(#ce76)
		add		hl,bc
		ld		(#ce76),hl
		jp		proc_51fc
val_51c7_in_rom_12c5	equ	proc_52c4

; BG1個分斜め上にずらして再チェック
proc_52ca:
		dec		(hl)
		dec		l
		dec		(hl)

		ld		bc,-21
		ld		hl,(#ce76)
		add		hl,bc
		ld		(#ce76),hl
		jp		proc_51fc
val_35_in_rom_12ca		equ	#c3
val_ec18_in_rom_12cb	equ	proc_52ca



;===============================================================
;
;===============================================================


;=======================================
;	(i)#ce74			map x y
;	(i)cur_bg_y			bgのスクロールオフセットy
;	(o)hl				bgのオフセットアドレスと、map x
;=======================================
get_bg_adr_from_ce74:
proc
		ex		af,af'

		ld		hl,(#ce74)		; x,y map pos
		ld		a,(cur_bg_y)
		rrca
		add		a,h
		sub		2
		and		#f
		ld		h,a
		xor		a
		rr		h
		rra
		rr		h
		rra
		add		a,l
		ld		l,a

		ex		af,af'
		ret
endp
;=======================================
;
;=======================================
get_bg_adr_from_ce74_to_ce7c:
		call	get_bg_adr_from_ce74
		ld		(#ce7c),hl
		ret


;=======================================
;
;=======================================
putchr16x16_plusHalf:
		ld		ixl,1
		jp		putchr16x16_plusHalf_
putchr16x16:
		ld		ixl,0
putchr16x16_plusHalf_:
		push	de
		call	proc_5c47		; mapピース→mapBG番号格納アドレス変換 de=0x7c96+a*4
		ex		de,hl
;=======================================
; (i)hl				chr src
; (i)de				bgのオフセットアドレスと、map x
; (i)ixl			bgの追加xオフセット
;=======================================
putchr16x16_:
proc
		ld		a,d
		and		#03
		or		#40
		ld		d,a

		ld		a,(#0007)
		ld		c,a

		ld		a,d
		rlca
		rlca
		and		3

		inc		c
		di
		out		(c),a
		ld		a,#8e
		out		(c),a
		ei
		dec		c

		ld		a,e
		and		#e0
		add		a,ixl
		ld		ixl,a
		ld		a,e
		and		#1f
		add		a,a
		ld		e,a

		ld		ixh,2

	_lpY:
		push	de
		ld		b,8

		ld		a,e
		cp		7
		jr		c,_cutL
		cp		31
		jr		c,_putLR
	;_cutR:					; 1f<=x
		; 描画範囲になるプレーンまで移動
		sub		31
		ld		b,a
		add		a,a
		add		a,a
		add		a,d
		ld		d,a	
		; クリップなし描画回数=x-31
		ld		a,7
		sub		b
		ld		b,a
		add		a,a
		add		a,b
		inc		a
		ld		b,a
		; 画面右端に左側描画
		ld		e,31
		ld		a,e
		add		a,ixl
		inc		c
		di
		out		(c),a
		out		(c),d
		ei
		dec		c
		ld		a,(hl)
		out		(c),a
		jp		_putLR2
	_cutL:					; x<7
		; クリップなし描画回数=x+1
		inc		a
		ld		b,a
	_putLR:
		; 繰り返し回数修正(djnz+outi+outd)
		ld		a,b
		add		a,a
		add		a,b
		ld		b,a
	_lp_putLR:
		; 各プレーンにクリップなしの描画
		ld		a,ixl		; yオフセットアドレス
		add		a,e			; xオフセットアドレス
		inc		c
		di
		out		(c),a
		out		(c),d
		dec		c
		outi
		ei
		outd
	_putLR2:
		; 次のプレーンに
		ld		a,d
		add		a,4
		ld		d,a
		; プレーン内x座標修正
		dec		e
		djnz	_lp_putLR

		jp		p,_next_line
	;_putR:
		; 画面左端に右側描画
		ld		a,ixl
		inc		c
		di
		out		(c),a
		out		(c),d
		ei
		dec		c
		inc		hl
		ld		a,(hl)
		out		(c),a
		dec		hl

	_next_line:
		pop		de
		dec		ixh
		jr		z,put16x16_ret

		; 下段側のソースへ
		inc		hl
		inc		hl

		; y座標を下段へ
		ld		a,ixl
		add		a,32
		ld		ixl,a
		jp		nc,_lpY
		inc		d
		ld		a,d
		and		#03
		or		#40
		ld		d,a
		jp		_lpY
endp
put16x16_ret:
		pop		de
		ret


;=======================================
;
;=======================================
val_2a_in_rom_13b5		equ	#cd
val_ce7c_in_rom_13b4	equ	get_bg_adr_from_ce74
val_29_in_rom_13b9		equ	32
val_5666_in_rom_13c2	equ	putchr16x16_plusHalf

val_2a_in_rom_13d4		equ	#cd
val_ce7c_in_rom_13d5	equ	get_bg_adr_from_ce74
val_50_in_rom_13f4		equ	32*2
val_5666_in_rom_13e1	equ	putchr16x16
val_23_in_rom_13e6		equ	0
val_5666_in_rom_13e9	equ	putchr16x16

val_2a_in_rom_1408		equ	#cd
val_ce7c_in_rom_1409	equ	get_bg_adr_from_ce74
val_5666_in_rom_140c	equ	putchr16x16

val_2a_in_rom_1434		equ	#cd
val_ce7c_in_rom_1435	equ	get_bg_adr_from_ce74
val_5666_in_rom_1438	equ	putchr16x16

val_2a_in_rom_1501		equ	#cd
val_ce7c_in_rom_1502	equ	get_bg_adr_from_ce74
val_5666_in_rom_1505	equ	putchr16x16

val_2a_in_rom_155e		equ	#cd
val_ce7c_in_rom_155f	equ	get_bg_adr_from_ce74_to_ce7c
val_5666_in_rom_1564	equ	putchr16x16
val_23_in_rom_158c		equ	0
val_5666_in_rom_1591	equ	putchr16x16;_XPlus2
val_50_in_rom_15b0		equ	32*2
val_5666_in_rom_15b9	equ	putchr16x16
val_52_in_rom_15db		equ	32*2+1
val_5666_in_rom_15e4	equ	putchr16x16;_XPlus2
