;===============================================================
;  MSX STAR SOLDIER
;
;	スムーススクロール
;
;===============================================================
romadr	#0000
incbin "StarSoldier.rom"
include "StarSoldier-ss-def.asm"
include "StarSoldier-ss-q.asm"

if 0	;無敵
	val_20_in_rom_0fdc	equ	#18
	val_28_in_rom_0ff6	equ	#18
endif

macro	filler,ed
	_filler:
		if	0x4000+ed < _filler
			.ERROR	ed < _filler
		endif
		if	_filler < 0x4000+ed
			ds	0x4000+ed - _filler
		endif
endm

romadr	#01be
include "StarSoldier-ss-001be.asm"			; ボスPCG配置
include	"StarSoldier-ss-set_vram_adr.asm"
filler	#01fc

romadr	#0410
include "StarSoldier-ss-00410.asm"			; ボスのフェード色を4ブロック目も更新
filler	#0424

romadr	#04ff
org		#44ff
ret											; ボス戦用の画面更新やめる
include	"StarSoldier-ss-blt_to_vram.asm"
filler	#0522

romadr	#04bb
include "StarSoldier-ss-004bb.asm"			; ボスPCG書き込み
filler	#04e7

romadr	#07a5
org		#47a5								; HTIMI削除
		ret
filler	#07b1

romadr	#0846
include "StarSoldier-ss-00846.asm"			; 基本PCG書き込み
filler	#08a0

romadr	#0932
include "StarSoldier-ss-00932.asm"			; 自機表示
filler	#09f2

romadr	#0a78
include "StarSoldier-ss-00a78.asm"			; 自機爆発スプライト位置修正
filler	#0abd

romadr	#0c80
include "StarSoldier-ss-00c80.asm"			; 自弾移動
filler	#0ccd

romadr	#0f3e
include "StarSoldier-ss-00f3e.asm"			; 自弾表示
filler	#0f6b

romadr	#10a2
include "StarSoldier-ss-010a2.asm"			; 自弾vsBG 当たり判定
filler	#122f

romadr	#1666
org		#5666
filler	#1683

romadr	#171b
include "StarSoldier-ss-0171b.asm"			; 当たり判定
filler	#1755

romadr	#180e
include "StarSoldier-ss-0180e.asm"			; メッセージ表示処理
filler	#19a3

romadr	#1a60
include "StarSoldier-ss-01a60.asm"			; タイトル配置
DecompressLZSA_to_d600:
		ld		de,#d600
DecompressLZSA:
		include	"StarSoldier-ss-unlzsa1_small.asm"
title_lzsa:
		incbin "StarSoldier-ss-title2.lzsa"
include "StarSoldier-ss-01b8c.asm"			; マップ処理
filler	#1c64

romadr	#1cb6
org		#5cb6
include "StarSoldier-ss-01cca.asm"			; マップ処理
map0_lzsa:
		incbin	"StarSoldier-ss-map0.lzsa"
map1_lzsa:
		incbin	"StarSoldier-ss-map1.lzsa"
map2_lzsa:
		incbin	"StarSoldier-ss-map2.lzsa"
include	"StarSoldier-ss-disp.asm"
include	"StarSoldier-ss-boss_disp.asm"
include	"StarSoldier-ss-star.asm"
filler	#2cb0

romadr	#30b0
org		#70b0
pcgcol_lzsa:
		incbin "StarSoldier-ss-pcgcol.lzsa"
include	"StarSoldier-ss-hitchk_shot.asm"
filler	#3c96

romadr	#48c9
include "StarSoldier-ss-048c9.asm"			; 爆風のスクロール修正
filler	#4960

romadr	#4cd5
include "StarSoldier-ss-04cd5.asm"			; 敵等表示
filler	#4d91

romadr	#4f71
include "StarSoldier-ss-04f71.asm"			; 敵弾表示
filler	#4fc9

romadr	#6c0c
org		#ac0c
PCGCOLPN_BOSS_LZSA:
		incbin "StarSoldier-ss-pcgcolpn_boss.lzsa"
DecompressLZSA_PCGCOLPN_BOSS:
		ld		(#ce7f),hl
		ld		hl,PCGCOLPN_BOSS_LZSA
		jp		DecompressLZSA_to_d600
val_22_in_rom_00163		equ	#cd
val_ce7f_in_rom_00164	equ DecompressLZSA_PCGCOLPN_BOSS
val_22_in_rom_019dc		equ	#cd
val_ce7f_in_rom_019dd	equ DecompressLZSA_PCGCOLPN_BOSS

include	"StarSoldier-ss-pcg.asm"
filler	#709f
