;===============================================================
;  MSX STAR SOLDIER
;
;	定義
;
;	VRAM
;	PGT		0000-17ff	;メッセージ用	r4:3
;	SGT		1800-1fff
;	CT		2000-37ff	;メッセージ用	r10:00
;	PNT		3800-3bff	;メッセージ用

;	SAT		3c00 3d00 3e00 3f00			r11:0	;ゲーム画面用
;			  78   7a   7c   7e
;	SAT		3c80 3d80 3e80 3f80			r11:0	;メッセージ用
;			  79   7b   7d   7f

;	ゲーム画面用
;	PNT	4000 4400 4800 4c00 5000 5400 5800 5c00
;		  10   11   12   13   14   15   16   17
;		6000 6400 6800 6c00 7000 7400 7800 7c00
;		  18   19   1a   1b   1c   1d   1e   1f
;	PGT		8000-9fff					r4:13
;	PGT1	A000-bfff					r4:17
;	PGT2	c000-dfff					r4:1b
;	CT		e000-ffff					r10:03
;
;	hscanのゴミ消し用
;	CT		12000-13fff					r10:04
;===============================================================




HKEYI			equ	#fd9a

disp_page_tbl	equ	#d000
	; page0	xy-adj
	;		y-scr-ofs
	;		vdp PNT val
	;		vdp SAT val
	; page1
	;		;
	; page2
	;		;
	; page3
	;		;
fore_page		equ	disp_page_tbl+4*4
back_page		equ	fore_page+1
back_sat		equ	fore_page+2
cur_bg_adr		equ	fore_page+4
cur_putbg_state	equ	fore_page+6
cur_bg_y		equ	fore_page+8
cur_boss_src	equ	fore_page+9
boss_scr_y_org	equ	fore_page+11
putsprite		equ	fore_page+12
putsprite_enemy	equ	fore_page+15


star_cnt			equ	3
star_page_cnt		equ	3
star_page_size		equ	2 + star_cnt
star_page_tbl		equ	#d030
	; page0 pgt vdp(4) val
	; 		pgt high adr
	;		last pgt low adr  x star_cnt
	; page1
	;		;
	; page2
	;		;
star_back_page		equ	star_page_tbl + star_page_size * star_page_cnt
star_fore_pgt		equ	star_back_page+1
star_y_tbl			equ	star_fore_pgt+1
star_last_src_y		equ	star_y_tbl + star_cnt
star_boss_shift_x	equ	star_last_src_y+1


hscan_proc		equ	#d050
hscan_adr		equ	hscan_proc+2

tmp_sat			equ	#d100
map_data		equ	#d600


